package com.dahe.examine.ui.account

import android.Manifest
import android.graphics.drawable.BitmapDrawable
import android.os.Bundle
import android.text.TextUtils
import android.text.method.HideReturnsTransformationMethod
import android.text.method.PasswordTransformationMethod
import android.view.View
import com.dahe.examine.R
import com.dahe.examine.bean.CheckCodeBean
import com.dahe.examine.bean.LogBean
import com.dahe.examine.bean.UserBean
import com.dahe.examine.bean.UserBean2
import com.dahe.examine.net.BaseObserver
import com.dahe.examine.net.DataManager
import com.dahe.examine.net.RxHttpCallBack
import com.dahe.examine.ui.HomeActivity
import com.dahe.examine.utils.AppActivityUtils
import com.dahe.examine.utils.SPUtils
import com.dahe.mylibrary.base.BaseActivity
import com.dahe.mylibrary.net.CommonResponseBean
import com.dahe.mylibrary.net.JsonUtils
import com.dahe.mylibrary.utils.ActivityUtils
import com.dahe.mylibrary.utils.Base64Utils
import com.dahe.mylibrary.utils.MobileInfoUtils
import io.reactivex.rxjava3.android.schedulers.AndroidSchedulers
import io.reactivex.rxjava3.core.Observable
import io.reactivex.rxjava3.schedulers.Schedulers
import kotlinx.android.synthetic.main.activity_login.*
import pub.devrel.easypermissions.AppSettingsDialog
import pub.devrel.easypermissions.EasyPermissions
import java.util.*

class LoginActivity : BaseActivity(), EasyPermissions.PermissionCallbacks, View.OnClickListener {


    lateinit var codeBean: CheckCodeBean

    var perms = arrayOf(
        Manifest.permission.CAMERA,
        Manifest.permission.CALL_PHONE,
        Manifest.permission.ACCESS_FINE_LOCATION,
        Manifest.permission.WRITE_EXTERNAL_STORAGE
    )

    override fun getLayout(): Int = R.layout.activity_login

    override fun initView(savedInstanceState: Bundle?) {
//        setStatusBarCancelLightColor()
        setStatusBarColor(R.color.white)
        if (!EasyPermissions.hasPermissions(this, *perms)) {
            EasyPermissions.requestPermissions(this@LoginActivity, "您尚有权限未开放，是否获取权限", 2, *perms)
        }


        btn_log.setOnClickListener(this)
        tvForget.setOnClickListener(this)
        tv_yhxy.setOnClickListener(this)
        tv_yszc.setOnClickListener(this)
        imgCode.setOnClickListener(this)
        cb.setOnCheckedChangeListener { buttonView, isChecked ->
            if (isChecked) {
                et_pass.setTransformationMethod(PasswordTransformationMethod.getInstance())
            } else {
                et_pass.setTransformationMethod(HideReturnsTransformationMethod.getInstance())
            }
            et_pass.setSelection(et_pass.getText().toString().length)
        }
    }

    override fun initDate() {
        getCode()
    }

    override fun onClick(view: View) {
        when (view.id) {
            R.id.btn_log -> {
//                MobileInfoUtils().jumpStartInterface(this)

                if (!EasyPermissions.hasPermissions(this, *perms)) {
                    EasyPermissions.requestPermissions(
                        this@LoginActivity,
                        "您尚有权限未开放，是否获取权限",
                        2,
                        *perms
                    )
                } else {
                    logByPass()
                }

            }
            R.id.tv_yhxy -> {
                //            R.id.tv_forget -> ActivityUtils.startActivity(mContext, ForgetPwdActivity::class.java)
                AppActivityUtils.openWebViewActivity(this,
                    "用户服务协议",
                    "http://tms.down.user.test.dahehuodongbao.com/user-agreement.html")
            };
            R.id.tv_yszc -> //            R.id.tv_forget -> ActivityUtils.startActivity(mContext, ForgetPwdActivity::class.java)
            {
                AppActivityUtils.openWebViewActivity(this, "隐私政策",
                    "http://tms.down.user.test.dahehuodongbao.com/user-privacy.html")
            }

            R.id.imgCode ->//            R.id.tv_forget -> ActivityUtils.startActivity(mContext, ForgetPwdActivity::class.java)
                //            R.id.tv_forget -> ActivityUtils.startActivity(mContext, ForgetPwdActivity::class.java)
            {
                getCode()
            }


        }
    }

    override fun onRequestPermissionsResult(
        requestCode: Int,
        permissions: Array<String?>,
        grantResults: IntArray,
    ) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults)

        // EasyPermissions handles the request result.
        EasyPermissions.onRequestPermissionsResult(requestCode, permissions, grantResults, this)
    }

    private fun getCode() {
        DataManager.getInstance().captchaImage()
            .subscribeOn(Schedulers.io())
            .observeOn(AndroidSchedulers.mainThread())
            .subscribe(BaseObserver(mContext, object : RxHttpCallBack<CheckCodeBean>() {
                override fun onSuccess(t: CommonResponseBean<CheckCodeBean>) {
                    super.onSuccess(t)
                    codeBean = t.getData()
                    imgCode.setBackground(BitmapDrawable(Base64Utils.asdf(t.getData()
                        .getImage())))
                    imgCode.setText("")
                }
            }))
    }


    /**
     * 密码登录
     */
    private fun logByPass() {
        val s: String = et_phone.getText().toString().trim()
        val s1: String = et_pass.getText().toString().trim()
        if (TextUtils.isEmpty(s) || TextUtils.isEmpty(s1)) {
            showToast("请输入账号密码")
            return
        }
//        if (!PatternUtils.isPassword(s1)){
//            showToast("密码格式错误")
//            return
//        }
        if (etCode.text.toString().isEmpty()) {
            showToast("请输入验证码")
            return
        }
//        if (!cb_read.isChecked()) {
//            showToast("请勾选用户协议")
//            return
//        }

        if (!::codeBean.isInitialized){
            showToast("请获取验证码")
            return
        }

        val logBean = LogBean()
        logBean.username = et_phone.getText().toString().trim()
        logBean.password = et_pass.getText().toString().trim()
        logBean.code = etCode.getText().toString().trim()
        logBean.uuid = codeBean.uuid

        DataManager.getInstance().log2(logBean)
            .takeWhile {
                if (200!=it.code){
                    runOnUiThread {
                        showToast(it.msg)
                    }
                    false
                }else{
                    true
                }
            }
            .flatMap {
                SPUtils.setUserInfo(
                    this@LoginActivity,
                    JsonUtils.getInstance().getGson().toJson(it.getData())
                )
                DataManager.getInstance().info
            }.compose(DataManager.setThread())
            .subscribe(BaseObserver(mContext,object :RxHttpCallBack<UserBean2>(){
                override fun onSuccess(t: CommonResponseBean<UserBean2>?) {
                    super.onSuccess(t)
                    val data = t?.data

                    val userInfo = SPUtils.getUserInfo(mContext)
                    userInfo.setUserInfo(data?.user)

                    SPUtils.setUserInfo(
                        this@LoginActivity,
                        JsonUtils.getInstance().getGson().toJson(userInfo)
                    )
                    ActivityUtils.startActivity(this@LoginActivity,
                        HomeActivity::class.java)
                    finish()
                }
            }))


//        Observable.zip(DataManager.getInstance()
//            .log2(logBean), DataManager.getInstance().info, { item1, item2 ->
//            item2.data.token = item1.data.token
//            item2
//
//        })
//            .compose(DataManager.setThread())
//            .subscribe(BaseObserver(mContext, object : RxHttpCallBack<UserBean>() {
//                override fun onSuccess(t: CommonResponseBean<UserBean>) {
//                    super.onSuccess(t)
//                    SPUtils.setUserInfo(
//                        this@LoginActivity,
//                        JsonUtils.getInstance().getGson().toJson(t.getData())
//                    )
//
////                            val freighter = SPUtils.getUserInfo(this@LoginActivity).freighter
//
//                    ActivityUtils.startActivity(this@LoginActivity,
//                        HomeActivity::class.java)
//                    finish()
//                }
//            }))

    }


    override fun onPermissionsGranted(requestCode: Int, perms: MutableList<String>) {
    }

    override fun onPermissionsDenied(requestCode: Int, perms: MutableList<String>) {
        if (EasyPermissions.somePermissionPermanentlyDenied(this, perms)) {
            AppSettingsDialog.Builder(this).setTitle("获取权限")
                .setRationale("如果没有请求的权限，此应用可能无法正常工作。 打开应用程序设置屏幕以修改应用程序权限").build().show()
        }
    }
}