package com.dahe.examine.ui.account.activity

import android.os.Bundle
import android.text.TextUtils
import android.text.method.HideReturnsTransformationMethod
import android.text.method.PasswordTransformationMethod
import android.view.View
import com.dahe.mylibrary.base.BaseActivity
import com.dahe.mylibrary.net.CommonResponseBean
import com.dahe.mylibrary.utils.ActivityUtils
import com.dahe.mylibrary.utils.CountDownTimerUtils
import com.dahe.mylibrary.utils.PhoneFormatCheckUtils
import com.dahe.examine.R
import com.dahe.examine.base.AppConfig
import com.dahe.examine.bean.BusInfoBean
import com.dahe.examine.net.BaseObserver
import com.dahe.examine.net.DataManager
import com.dahe.examine.net.RxHttpCallBack
import com.dahe.examine.ui.HomeActivity
import com.dahe.examine.utils.AppActivityUtils
import kotlinx.android.synthetic.main.activity_login.*
import kotlinx.android.synthetic.main.activity_register.*
import kotlinx.android.synthetic.main.activity_register.btn_log
import kotlinx.android.synthetic.main.activity_register.cb
import kotlinx.android.synthetic.main.activity_register.etCode
import kotlinx.android.synthetic.main.activity_register.tv_yhxy
import kotlinx.android.synthetic.main.activity_register.tv_yszc
import java.util.*

class RegisterActivity : BaseActivity(), View.OnClickListener {


    override fun getLayout(): Int = R.layout.activity_register

    override fun initView(savedInstanceState: Bundle?) {
//        setStatusBarCancelLightColor()
        setStatusBarColor(R.color.white)


        btn_log.setOnClickListener(this)
        tv_yhxy.setOnClickListener(this)
        tv_yszc.setOnClickListener(this)
        tvCode.setOnClickListener(this)
        cb.setOnCheckedChangeListener { buttonView, isChecked ->
            if (isChecked) {
                et_pass.setTransformationMethod(PasswordTransformationMethod.getInstance())
            } else {
                et_pass.setTransformationMethod(HideReturnsTransformationMethod.getInstance())
            }
            et_pass.setSelection(et_pass.getText().toString().length)
        }
    }

    override fun initDate() {
//        getCode()
    }

    override fun onClick(view: View) {
        when (view.id) {
            R.id.btn_log -> next()
//            R.id.tv_forget -> ActivityUtils.startActivity(mContext, ForgetPwdActivity::class.java)
            R.id.tv_yhxy -> AppActivityUtils.openWebViewActivity(this,
                "用户服务协议",
                "https://tms.dahehuoyun.com/profile/upload/static/serviceAgreement.html");
            R.id.tv_yszc -> AppActivityUtils.openWebViewActivity(this, "隐私政策",
                "https://tms.dahehuoyun.com/profile/upload/static/privacyPolicy.html")


            R.id.tvCode -> getCode()

        }
    }


    /**
     * 密码登录
     */
    private fun logByPass() {
        val s: String = et_phone.getText().toString().trim()
        val s1: String = et_pass.getText().toString().trim()
        if (TextUtils.isEmpty(s) || TextUtils.isEmpty(s1)) {
            showToast("请输入账号密码")
            return
        }
//        if (!PatternUtils.isPassword(s1)){
//            showToast("密码格式错误")
//            return
//        }
//        if (et_yzm.text.toString().isEmpty()) {
//            showToast("请输入验证码")
//            return
//        }
//        if (!cb_read.isChecked()) {
//            showToast("请勾选用户协议")
//            return
//        }

        ActivityUtils.startActivity(this@RegisterActivity,
            HomeActivity::class.java)
        finish()

//        DataManager.getInstance().log(et_pass.getText().toString().trim(), et_phone.getText().toString().trim())
//            .subscribeOn(Schedulers.io())
//            .observeOn(AndroidSchedulers.mainThread())
//            .subscribe(
//                BaseObserver<UserBean>(mContext,
//                    object : RxHttpCallBack<UserBean?>(this@LoginActivity) {
//                        override fun onSuccess(t: CommonResponseBean<UserBean?>) {
//                            super.onSuccess(t)
////                            val toJson = JsonUtils.getInstance().getGson().toJson(t.getData())
//                            SPUtils.setUserInfo(
//                                this@LoginActivity,
//                                JsonUtils.getInstance().getGson().toJson(t.getData())
//                            )
//
////                            val freighter = SPUtils.getUserInfo(this@LoginActivity).freighter
//
//                            ActivityUtils.startActivity(this@LoginActivity,
//                                HomeActivity::class.java)
//                            finish()
//                        }
//
//                        override fun onCodeError(mContext: Context?, t: CommonResponseBean<UserBean?>) {
//                            super.onCodeError(mContext, t)
////                            if (t.getCode() != -1) {
////                                getCode()
////                            }
//                        }
//                    })
//            )
    }


    fun getCode() {

        var phone = etPhone.text.toString()
        if (PhoneFormatCheckUtils.isPhoneLegal(phone)) {
            DataManager.getInstance().getSmsCode(phone)
                .compose(DataManager.setThread())
                .subscribe(BaseObserver(mContext, object : RxHttpCallBack<Any>() {
                    override fun onSuccess(t: CommonResponseBean<Any>?) {
                        super.onSuccess(t)
                        val countDownTimerUtils = CountDownTimerUtils(tvCode, 60000, 1000)
                        countDownTimerUtils.start()
                    }
                }))
        } else {
            showToast("请输入正确手机号")
        }

    }

    fun next() {
        val phone = etPhone.text.toString()
        val code = etCode.text.toString()
        val pwd = etPass.text.toString()

        if (phone.isNullOrEmpty() || code.isNullOrEmpty() || pwd.isNullOrEmpty()) {
            showToast("请完善信息")
            return
        }
        val busInfoBean = BusInfoBean()
        busInfoBean.phone = phone

        val paramsDao = BusInfoBean.ParamsDao()
        paramsDao.code = code
        busInfoBean.params = paramsDao

        busInfoBean.pwd = pwd
        val bundle = Bundle()
        bundle.putSerializable(AppConfig.BEAN, busInfoBean)
        ActivityUtils.startActivity(mContext, BusinessInfoActivity::class.java, bundle)
    }

}