package com.dahe.examine.ui.gone.activity

import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import com.dahe.examine.R
import com.dahe.examine.adapter.UserDetailAdapter
import com.dahe.examine.base.AppConfig
import com.dahe.examine.bean.ApplyBean
import com.dahe.examine.bean.CountBean
import com.dahe.examine.net.BaseObserver
import com.dahe.examine.net.DataManager
import com.dahe.examine.net.RxHttpCallBack
import com.dahe.mylibrary.base.BaseActivity
import com.dahe.mylibrary.net.CommonResponseBean
import com.dahe.mylibrary.net.PagerBean
import kotlinx.android.synthetic.main.activity_user_detail.*
import kotlinx.android.synthetic.main.activity_user_detail.tvMf1
import kotlinx.android.synthetic.main.activity_user_detail.tvMf2
import kotlinx.android.synthetic.main.activity_user_detail.tvMf3
import kotlinx.android.synthetic.main.activity_user_detail.tvSf1
import kotlinx.android.synthetic.main.activity_user_detail.tvSf2
import kotlinx.android.synthetic.main.activity_user_detail.tvSf3
import kotlinx.android.synthetic.main.activity_user_detail.tvYf
import kotlinx.android.synthetic.main.activity_user_detail.tvYsp
import kotlinx.android.synthetic.main.activity_user_detail.tvYsy
import kotlinx.android.synthetic.main.fragment_gone.*
import kotlinx.android.synthetic.main.fragment_home.recyclerView
import retrofit2.http.Url
import java.net.URL
import java.net.URLEncoder

/**
 * @ClassName UserDetailActivity
 * @Author 用户
 * @Date 2022/1/17 10:02
 * @Description TODO
 */
class UserDetailActivity : BaseActivity() {
    lateinit var applyAdapter : UserDetailAdapter

    override fun getLayout() = R.layout.activity_user_detail

    override fun initView(savedInstanceState: Bundle?) {
        setStatusBarCancelLightColor()
        setTitleBar("已使用详情") { finish() }
        initRec()
    }

    override fun initDate() {
        val string = intent.extras?.getString(AppConfig.TIME)
        var bean = intent.extras?.getSerializable(AppConfig.BEAN) as ApplyBean
        tvTitle.text = bean.enterpriseName


        DataManager.getInstance().detailList(bean.userId,bean.chargeType,string)
            .compose(DataManager.setThread())
            .subscribe(BaseObserver(mContext, object : RxHttpCallBack<PagerBean<ApplyBean>>() {
                override fun onSuccess(t: CommonResponseBean<PagerBean<ApplyBean>>) {
                    super.onSuccess(t)
                    t.data.rows
                    applyAdapter.setList(t.data.rows)
                }
            }))
        getCount(bean.userId,string)
    }

    fun getCount(userId: String, string: String?) {
        DataManager.getInstance().useCount(userId,string)
            .compose(DataManager.setThread())
            .subscribe(BaseObserver(mContext,object : RxHttpCallBack<CountBean>(){
                override fun onSuccess(t: CommonResponseBean<CountBean>?) {
                    super.onSuccess(t)
                    tvYf.text = t?.data?.numberOfPasses
                    tvYsy.text = t?.data?.passNoNumber
                    tvYsp.text = t?.data?.notUsedNumber

                    tvMf1.text = t?.data?.numberOfPassesMF
                    tvMf2.text = t?.data?.passNoNumberMF
                    tvMf3.text = t?.data?.notUsedNumberMF
                    tvSf1.text = t?.data?.numberOfPassesSF
                    tvSf2.text = t?.data?.passNoNumberSF
                    tvSf3.text = t?.data?.notUsedNumberSF
                }
            }))
    }

    fun initRec() {
        recyclerView.layoutManager = LinearLayoutManager(mContext,
            LinearLayoutManager.VERTICAL, false)
        recyclerView.setHasFixedSize(true)
        applyAdapter = UserDetailAdapter(-1)
        recyclerView.adapter = applyAdapter


    }
}