package com.dahe.examine.ui.mine.activity

import android.os.Bundle
import android.view.View
import com.dahe.mylibrary.base.BaseActivity
import com.dahe.mylibrary.net.CommonResponseBean
import com.dahe.mylibrary.utils.CountDownTimerUtils
import com.dahe.mylibrary.utils.PhoneFormatCheckUtils
import com.dahe.examine.R
import com.dahe.examine.bean.ChangePwdBean
import com.dahe.examine.net.BaseObserver
import com.dahe.examine.net.DataManager
import com.dahe.examine.net.RxHttpCallBack
import com.dahe.examine.utils.SPUtils
import kotlinx.android.synthetic.main.activity_change_pwd.*

/**
 * @ClassName ChangePwdActivity
 * @Author 用户
 * @Date 2022/1/13 16:59
 * @Description TODO
 */
class ChangePwdActivity : BaseActivity(), View.OnClickListener {
    override fun getLayout() = R.layout.activity_change_pwd

    override fun initView(savedInstanceState: Bundle?) {
        setStatusBarCancelLightColor()
        setTitleBar("修改密码") { finish() }

//        val phone = SPUtils.getUserInfo(this).userInfo.phone
//        tvPhone.text = phone

        tvCode.setOnClickListener(this)
        btn_log.setOnClickListener(this)
    }

    override fun initDate() {
    }

    override fun onClick(view: View?) {
        super.onClick(view)
        when(view?.id){
            R.id.tvCode->getCode()
            R.id.btn_log->sub()
        }
    }

    fun sub(){

//        val phone = tvPhone.text.toString()
        val code = etPass.text.toString()
        val pwd = etCode.text.toString()

        if (pwd.isNullOrEmpty()||code.isNullOrEmpty()){
            showToast("请完善信息")
            return
        }
        if (code!=pwd){
            showToast("两次输入不一致")
            return
        }

        val userId = SPUtils.getUserInfo(mContext).userInfo.userId

        val changePwdBean = ChangePwdBean()
        changePwdBean.password = code
        changePwdBean.userId =userId

        DataManager.getInstance().changePwd(changePwdBean)
            .compose(DataManager.setThread())
            .subscribe(BaseObserver(mContext,object : RxHttpCallBack<Any>(){
                override fun onSuccess(t: CommonResponseBean<Any>?) {
                    super.onSuccess(t)
                    finish()
                }
            }))
    }

    fun getCode() {

        var phone = etCode.text.toString()
        if (PhoneFormatCheckUtils.isPhoneLegal(phone)) {
            DataManager.getInstance().getSmsCode(phone)
                .compose(DataManager.setThread())
                .subscribe(BaseObserver(mContext, object : RxHttpCallBack<Any>() {
                    override fun onSuccess(t: CommonResponseBean<Any>?) {
                        super.onSuccess(t)
                        val countDownTimerUtils = CountDownTimerUtils(tvCode, 60000, 1000)
                        countDownTimerUtils.start()
                    }
                }))
        } else {
            showToast("请输入正确手机号")
        }

    }
}